/**
 * Class PythagorasTriangle
 * @author Jan Christian Grünhage
 */
public class PythagorasTriangle {
    private double leftSizeFactor;
    private double leftAngle;
    private double rightSizeFactor;
    private double rightAngle;

    public PythagorasTriangle(PythagorasTree.PythagorasTreeVariant variant, int momentaryDepth, Fibonacci fibonacci, Double angle) {

        switch (variant) {


            case SymetricPythagorasTree:
                leftAngle = 45;
                break;


            case AsymetricPythagorasTree:
                if (angle < 0 || angle > 90) return;
                leftAngle = angle;
                break;


            case RegularRandomPythagorasTree:
                leftAngle = Math.random() * 50 + 20;
                break;


            case PisanoPythagorasTreeOne:
                leftAngle = (fibonacci.calcFibonacci(momentaryDepth) % 4) * 10 + 30;
                break;


            case PisanoPythagorasTreeTwo:
                leftAngle = (fibonacci.calcFibonacci(momentaryDepth) % 2) * 30 + 30;
                break;


            case PisanoPythagorasTreeThree:
                leftAngle = (fibonacci.calcFibonacci(momentaryDepth) % 7) * 5 + 30;
                break;


            case PisanoPythagorasTreeFour:
                leftAngle = (fibonacci.calcFibonacci(momentaryDepth) % 31) + 30;
                break;


            case PisanoPythagorasTreeFive:
                leftAngle = (fibonacci.calcFibonacci(momentaryDepth) % 9) * 4 + 29;
                break;

            default:
                leftAngle = 45;
                break;
        }
        rightAngle = (double) 90 - leftAngle;
        leftSizeFactor = Math.sin(Math.toRadians(leftAngle));
        rightSizeFactor = Math.sin(Math.toRadians(rightAngle));
    }
    public double getLeftSizeFactor() {
        return leftSizeFactor;
    }

    public double getLeftAngle() {
        return leftAngle;
    }

    public double getRightSizeFactor() {
        return rightSizeFactor;
    }

    public double getRightAngle() {
        return rightAngle;
    }
}
